

#include "stdafx.h"
#include "pgsnd.h"

enum PocketGSound
{
	WaveInit	,
	WaveClose	,
	WaveActivate,
	WavePlay,
	WaveStop,
	WaveSetVolume,
	WaveSetChannelVolume,
	LoadWaveFile,
	NumofFunction
};

FUNC_DECLARE(	WaveInit	)
FUNC_DECLARE(	WaveClose	)
FUNC_DECLARE(	WaveActivate)
FUNC_DECLARE(	WavePlay	)
FUNC_DECLARE(	WaveStop)
FUNC_DECLARE(	WaveSetVolume)
FUNC_DECLARE(	WaveSetChannelVolume	)
FUNC_DECLARE(	LoadWaveFile	)


//		cao yuchao          	071600	FunctionPtrs to access the memory
AccessMemory lpSetData = NULL; 
AccessMemory lpGetData = NULL; 

PKTLIBRARY_API LibraryInit(AccessMemory lpSet, AccessMemory lpGet) 
{ 
	lpSetData = lpSet;	
	lpGetData = lpGet;  
}
//		cao yuchao          	071600	This function is called before the library is 
//										unloaded by the vm

PKTLIBRARY_API LibraryFree() 
{
	ASSERT(lpSetData);
	ASSERT(lpGetData);

	lpSetData = NULL;	
	lpGetData = NULL;  
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// common code for all pktlibrary
// keep it here
PKTLIBRARY_COMMON_CODEBLOCK 


void FunctionAssign()
{
FUNC_ASSIGN(	WaveInit	)
FUNC_ASSIGN(	WaveClose	)
FUNC_ASSIGN(	WaveActivate)
FUNC_ASSIGN(	WavePlay	)
FUNC_ASSIGN(	WaveStop)
FUNC_ASSIGN(	WaveSetVolume)
FUNC_ASSIGN(	WaveSetChannelVolume	)
FUNC_ASSIGN(	LoadWaveFile	)

}

 
FUNC_DEFINE(WaveInit	)
	// in: pg_WaveInit(HWND hWndApp, int nPlayBackRate, int nMixChunkSize, int nMaxChannel);
	// ret: bool
	bool bResult=pg_WaveInit((HWND)arrayArg[0].iVal, arrayArg[1].iVal, arrayArg[2].iVal, arrayArg[3].iVal);
	retVal.SetVal((int)bResult);
FUNC_END

FUNC_DEFINE(WaveClose	)
	// in:	none
	// ret: none
	pg_WaveClose();
FUNC_END

FUNC_DEFINE(WaveActivate	)
	// in:	bool
	// ret: none
	pg_WaveActivate(arrayArg[0].iVal);
FUNC_END


FUNC_DEFINE(WavePlay	)
	// in:	int, bool
	// ret: none
	pg_WavePlay(arrayArg[0].iVal, arrayArg[1].iVal);
FUNC_END

FUNC_DEFINE(WaveStop	)
	// in:	int
	// ret: none
	pg_WaveStop(arrayArg[0].iVal);
FUNC_END

FUNC_DEFINE(WaveSetVolume	)
	// in:	int
	// ret: none
	pg_WaveSetVolume(arrayArg[0].iVal);
FUNC_END

FUNC_DEFINE(WaveSetChannelVolume	)
	// in:	int,int,int
	// ret: none
	pg_WaveSetChannelVolume(arrayArg[0].iVal,arrayArg[1].iVal,arrayArg[2].iVal);
FUNC_END


FUNC_DEFINE(LoadWaveFile	)
	// in:	string, int
	// ret: bool
	BOOL bResult = pg_LoadWaveFile(arrayArg[0].sVal.GetBuffer(), arrayArg[1].iVal);
	retVal.SetVal(bResult);
FUNC_END


// Special Case:
// Creating windows.  PocketC app is actually running 2 threads.
// main thread is the UI thread
// worker thread is the Virtual machine processing the byte code.
// That is why if we want to create a window, we need to use this mechanism to create it in the UI thread

#define PKSMSG_WNDCREATE  0x0400+100
// Let us create a new function that is a bit different than createctrl1
// we need to take the main window hwnd since we are in the dll which can not get
// the main window handle directly.
// We also pass in a pointer for the x, y, w, h values.


// For example:
// int rect[] = { 0,0, 50, 50 }; // x,y,w,h values
// createctrl2(string strCtrl, string strName, int nStyle, int nExStyle, 
//				pointer pos, int nID,
//				int parentId, int mainHwnd)

struct	PocketWndData
		{
			int		x,y,w,h;
			DWORD	style;
			DWORD	exstyle;
			int		parentID;
			TCHAR	classname[256];
			TCHAR   windowname[1024];
		};
/*
FUNC_DEFINE(demoWndCreate	)
	
	ASSERT(arrayArg);
	retVal.SetVal(-1);
	
	PocketWndData wndData;

	_tcscpy(wndData.classname,arrayArg[0].TStr());
	_tcscpy(wndData.windowname,arrayArg[1].TStr());
	wndData.style = arrayArg[2].Int();
	wndData.exstyle = arrayArg[3].Int();

	CVMStackEntry e;
	
	lpGetData(arrayArg[4].iVal, e);	// get x value using its pointer
	wndData.x = e.iVal;

	lpGetData(arrayArg[4].iVal+1, e);	// get y value using its pointer
	wndData.y = e.iVal;

	lpGetData(arrayArg[4].iVal+2, e);	// get w value using its pointer
	wndData.w = e.iVal;

	lpGetData(arrayArg[4].iVal+3, e);	// get h value using its pointer
	wndData.h = e.iVal;

	wndData.parentID = arrayArg[6].Int();
	
	HWND mainWnd = (HWND) arrayArg[7].Int();
	retVal.SetVal( (int)SendMessage(mainWnd,	PKSMSG_WNDCREATE,
		(WPARAM)	arrayArg[5].Int(),
		(LPARAM)	&wndData));

FUNC_END*/


