// StackEntry.h: interface for the CStackEntry class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STACKENTRY_H__9149B886_B527_4387_8CA9_34AA6EFD7F05__INCLUDED_)
#define AFX_STACKENTRY_H__9149B886_B527_4387_8CA9_34AA6EFD7F05__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CVMStackEntry 
{

public:
	
	// Default constructor and distructor ----------
	CVMStackEntry();
	virtual ~CVMStackEntry();

	// Fancy constructors ----------------------------
	CVMStackEntry(int n) { SetVal(n); }
	CVMStackEntry(wchar_t c) { SetVal(c); }
	CVMStackEntry(double f) { SetVal(f); }
	CVMStackEntry(ustring s) { SetVal(s); }
	CVMStackEntry(LPCTSTR s) { SetVal(s); } 

	// Data ----------------------------------------
	VarType	m_vtType;
	union	
	{
		int				iVal;
		double			fVal;
		wchar_t			cVal;
	
	};
	ustring	sVal;
	
	// Type	Access-----------------------------------
	VarType GetType()			 { return m_vtType; }
	void	SetType(VarType vt) { m_vtType = vt;   }

	void	Truth();
	void	GetStringVal(CUnicodeString &us);
	void	GetStringType(CUnicodeString &us);
	
	// Operators ------------------------------------
	CVMStackEntry &operator=(const CVMStackEntry& entry);
	
	// Data Access ----------------------------------
	void	SetVal(int n) { iVal = n; m_vtType = vtInt; }
	void	SetVal(wchar_t c) { cVal = c; m_vtType = vtChar; }
	void	SetVal(double f) { fVal = f; m_vtType = vtFloat; }
	void	SetVal(ustring &s) { sVal = s; m_vtType = vtString; }
	void	SetVal(LPCTSTR s) { sVal = s; m_vtType = vtString; }
	void	SetVal(DWORD n) { iVal = n; m_vtType = vtInt; }

	void	FreeMem()			{	sVal.Empty(); m_vtType = vtInt;}

	DWORD	Int() { return iVal; }
	double	Float(){ return fVal; }
	TCHAR	Char(){ return cVal; }
	wchar_t*  TStr(){ return sVal.GetBuffer(); }
	

	friend bool	operator ==(const CVMStackEntry& s1, const CVMStackEntry& s2);
};

// Helper functions ---------------------------------

void	Truth(CVMStackEntry &v);
int		Compare(CVMStackEntry& l, CVMStackEntry& r);
void	TypeCast(CVMStackEntry & v, VarType type);
bool	operator ==(const CVMStackEntry& s1, const CVMStackEntry& s2);

#endif // !defined(AFX_STACKENTRY_H__9149B886_B527_4387_8CA9_34AA6EFD7F05__INCLUDED_)
