#ifndef INC_PKTLIBRARY_H
#define INC_PKTLIBRARY_H

#define PKTLIBRARY_EXPORTS

#ifdef PKTLIBRARY_EXPORTS
#define PKTLIBRARY_API extern "C" void __declspec(dllexport) __stdcall 
#else
#define PKTLIBRARY_API extern "C" void __declspec(dllimport) __stdcall 
#endif

#define PKTLIBRARY_EXPORTS_C 

#ifdef PKTLIBRARY_EXPORTS_C
#define PKTLIBRARY_API_C  __declspec(dllexport) 
#else
#define PKTLIBRARY_API_C __declspec(dllimport) 
#endif


//Macro Helpers
#define FUNC_DECLARE(fName)		void Func_##fName(CVMStackEntry &retVal,UINT nArg,CVMStackEntry* arrayArg);
#define FUNC_ASSIGN(fName)		g_Execute[fName] = Func_##fName;

#define FUNC_DEFINE(fName)		void Func_##fName(CVMStackEntry &retVal,UINT nArg,CVMStackEntry* arrayArg)  { 
#define FUNC_END				} 

// Global Function Pointer Array
typedef void (*LibraryFunction)(CVMStackEntry &retVal,UINT nArg,CVMStackEntry* arrayArg);
typedef bool (*AccessMemory)(unsigned long ulAddress, CVMStackEntry & dataVal);

void FunctionAssign(); 

class Lib
{
public:
	Lib()
	{
		FunctionAssign();
	}
};


//		cao yuchao          	071200	big macro to make the actual lib file easier to read
#define PKTLIBRARY_COMMON_CODEBLOCK   LibraryFunction	g_Execute[NumofFunction]; \
									  Lib gLib; \
PKTLIBRARY_API LibraryCall(int nFuncID, CVMStackEntry &retVal,UINT nArg,CVMStackEntry* arrayArg) \
{ \
	ASSERT(nFuncID < NumofFunction); \
	if (nFuncID >= NumofFunction) return; \
	g_Execute[nFuncID](retVal,nArg,arrayArg); \
} 


#define arg	arrayArg

#define hErr(EXP) { if ( EXP == false) goto HandleError; }


#endif
/*#ifdef _DEBUG
#pragma comment(lib, "compilerd.lib")
#pragma comment(lib, "sharelibd.lib")
#pragma comment(linker, "/NODEFAULTLIB:libcd.lib")
#else
#pragma comment(lib, "compiler.lib")
#pragma comment(lib, "sharelib.lib")
#pragma comment(linker, "/NODEFAULTLIB:libc.lib")
#endif
*/


#ifndef __CeDebug_h__
#define __CeDebug_h__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define HANDLE_EXCEPTION(n)	\
	((GetExceptionCode() ==(n)) ? EXCEPTION_EXECUTE_HANDLER: EXCEPTION_CONTINUE_SEARCH)

// Define TRACE behavior
#ifndef _DEBUG
	inline void CeTrace(LPCTSTR, ...) { }
	inline void CeAssert(BOOL, LPCTSTR) { }
	inline void CeAssert(BOOL) { }
#  define TRACE						1 ? (void)0 : ::CeTrace
#  define TRACE0(sz)
#  define TRACE1(sz, p1)
#  define TRACE2(sz, p1, p2)
#  define TRACE3(sz, p1, p2, p3)
#  define ISVALIDPTR(p, sz)
#else
	void CeTrace(LPCTSTR lpszFormat, ...);
	void CeAssert(BOOL bExp, LPCTSTR lpszFormat);
	void CeAssert(BOOL bExp);
#  define TRACE						::CeTrace
#  define TRACE0(sz)				::CeTrace(_T("%s"), _T(sz))
#  define TRACE1(sz, p1)			::CeTrace(sz, p1)
#  define TRACE2(sz, p1, p2)		::CeTrace(sz, p1, p2)
#  define TRACE3(sz, p1, p2, p3)	::CeTrace(sz, p1, p2, p3)
#  define ISVALIDPTR(p, sz)			(p != NULL && !IsBadReadPtr((void*)p, sz) && !IsBadWritePtr((void*)p, sz))
#endif

//#ifdef _DEBUG
#  define TRAP(_stmt) \
	__try { _stmt; } \
    __except (EXCEPTION_EXECUTE_HANDLER) \
	{ \
		::MessageBox(NULL, L#_stmt, _T("Exception trapped"), MB_OK | MB_ICONSTOP); \
	}
//#else
//#  define TRAP(_stmt)	_stmt
//#endif

// Define ASSERT behavior
#if defined(_DEBUG) && defined(_WIN32_WCE)
#  ifdef UNICODE
#    define CHW_ASSERT(_exp)		::CeAssert(BOOL(_exp), L"Assert Failed: " L#_exp)
#  else
#    define CHW_ASSERT(_exp)		::CeAssert(BOOL(_exp), "Assert Failed: " #_exp)
#  endif
#elif defined(_DEBUG)
#  include <crtdbg.h>
#  define CHW_ASSERT(exp)			_ASSERTE(exp)
#else
#  define CHW_ASSERT(exp)
#endif

#undef ASSERT
#ifndef ASSERT
#  define ASSERT(exp)				CHW_ASSERT(exp)
#endif

#undef ASSERT_VALID
#ifndef ASSERT_VALID
#  define ASSERT_VALID(p)			ISVALIDPTR(p, sizeof *p)
#endif

#undef _ASSERTE
#ifndef _ASSERTE
#  define _ASSERTE(exp)				CHW_ASSERT(exp)
#endif

#undef VERIFY
#ifndef VERIFY
#  ifdef _DEBUG
#    define VERIFY(exp)				ASSERT(exp)
#  else
#    define VERIFY(exp)				((void)(exp))
#  endif
#endif


#endif __CeDebug_h__