/*

Copyright (c) 1997-2001 TDRD Limited Partnership

Module Name:

    pgsnd.h

Abstract:

    dynamic wave mixer defines.

*/

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef PGSNDDEMO_EXPORTS
#define PGSND_EXPORTS
#endif

#ifdef PGSND_EXPORTS
#define PGAPI __declspec(dllexport)
#else
#define PGAPI __declspec(dllimport)
#endif

/* dynamic sound mixer APIs */
BOOL PGAPI pg_WaveInit(HWND, int, int, int);
void PGAPI pg_WaveClose(void);
void PGAPI pg_WaveActivate(BOOL);
void PGAPI pg_WavePlay(int, BOOL);
void PGAPI pg_WaveStop(int);
void PGAPI pg_WaveSetVolume(int);
void PGAPI pg_WaveSetChannelVolume(int, int, int);
BOOL PGAPI pg_LoadWaveResource(HMODULE, int, int);
BOOL PGAPI pg_LoadWaveFile(TCHAR *, int);

#ifndef DEMO
/* MOD music APIs - not available for demo version */
BOOL PGAPI pg_LoadMod(TCHAR*);
BOOL PGAPI pg_PlayMod(void);
BOOL PGAPI pg_StopMod(void);
void PGAPI pg_SetMusicVolume(int);
#endif

#ifdef __cplusplus
}
#endif
