/*
  This is a part of the TDRD Source Code Samples. 
  Copyright (C) 1997-2001 TDRD Ltd.,Part.
  All rights reserved. 

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.

  Copyright 1997-2001 TDRD Ltd.,Part. All Rights Reserved.

  PROGRAM: opendlg.c

  PURPOSE: A simple file browser dialog

  PLATFORMS: Windows CE
*/

#include <windows.h>

static TCHAR szCurrentPath[128] = TEXT("\\");
static TCHAR *szFileName;
static TCHAR szFileExt[4];

static TCHAR *getfilename(TCHAR *fullpath)
{
  int n = lstrlen(fullpath);

  while(n > 0)
  {
    if(fullpath[n] == '\\')
    {
      n++;
      break;
    }

    n--;
  }

  return fullpath + n;
}

static void backstep(void)
{
  int n = lstrlen(szCurrentPath);

  while(n > 0)
  {
    if(szCurrentPath[n] == '\\')
      break;

    n--;
  }

  if(n<1) n = 1;
  szCurrentPath[n] = 0;
}

static void scanfiles(HWND hPath, HWND hLB)
{
  WIN32_FIND_DATA ff;
  HANDLE hfind;
  TCHAR szf[128], *fn;

  SetWindowText(hPath,szCurrentPath);
  SendMessage(hLB,LB_RESETCONTENT,0,0);
  SendMessage(hLB,LB_ADDSTRING,0,(LPARAM)TEXT("[root]"));
  SendMessage(hLB,LB_ADDSTRING,0,(LPARAM)TEXT("[..]"));

  // scan file name
  if(lstrlen(szCurrentPath) > 1)
    wsprintf(szf,TEXT("%s\\*.%s"),szCurrentPath,szFileExt);
  else
    wsprintf(szf,TEXT("%s*.%s"),szCurrentPath,szFileExt);

  hfind = FindFirstFile(szf,&ff);

  if(hfind != INVALID_HANDLE_VALUE)
  {
    do
    {
      if(!(ff.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
      {
        fn = getfilename(ff.cFileName);
        SendMessage(hLB,LB_ADDSTRING,0,(LPARAM)fn);
      }
    } while(FindNextFile(hfind,&ff));

    FindClose(hfind);
  }

  // scan dir
  if(lstrlen(szCurrentPath) > 1)
    wsprintf(szf,TEXT("%s\\*.*"),szCurrentPath);
  else
    wsprintf(szf,TEXT("%s*.*"),szCurrentPath);

  hfind = FindFirstFile(szf,&ff);

  if(hfind != INVALID_HANDLE_VALUE)
  {
    do
    {
      if(ff.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
      {
        wsprintf(szf,TEXT("<%s>"),getfilename(ff.cFileName));
        SendMessage(hLB,LB_ADDSTRING,0,(LPARAM)szf);
      }
    } while(FindNextFile(hfind,&ff));

    FindClose(hfind);
  }
}

LRESULT CALLBACK OpenDlg(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  int i;

  switch(msg)
  {
  case WM_INITDIALOG:
    szFileName = (TCHAR*)lParam;
    lstrcpy(szFileExt,szFileName);
    scanfiles(GetDlgItem(hDlg,101),GetDlgItem(hDlg,100));
    SetWindowText(hDlg,TEXT("Open PCM WAVE"));
    break;

  case WM_COMMAND:
    switch(LOWORD(wParam))
    {
    case 100:
      if(HIWORD(wParam) != LBN_DBLCLK)
        break;

    case IDOK:
      i = SendMessage(GetDlgItem(hDlg,100),LB_GETCURSEL,0,0);

      if(i != LB_ERR)
      {
        if(i==0)
        {
          // go to root
          lstrcpy(szCurrentPath,TEXT("\\"));
          scanfiles(GetDlgItem(hDlg,101),GetDlgItem(hDlg,100));
        }
        else if(i==1)
        {
          // walk back one step
          backstep();
          scanfiles(GetDlgItem(hDlg,101),GetDlgItem(hDlg,100));
        }
        else
        {
          TCHAR szitem[128];
          SendMessage(GetDlgItem(hDlg,100),LB_GETTEXT,i,(LPARAM)szitem);

          if(szitem[0] == '<')
          {
            // chg dir
            if(lstrlen(szCurrentPath)>1)
              lstrcat(szCurrentPath,TEXT("\\"));

            szitem[lstrlen(szitem)-1] = 0;
            lstrcat(szCurrentPath,szitem+1);
            scanfiles(GetDlgItem(hDlg,101),GetDlgItem(hDlg,100));
          }
          else
          {
            // select file
            if(lstrlen(szCurrentPath)>1)
              wsprintf(szFileName,TEXT("%s\\%s"),szCurrentPath,szitem);
            else
              wsprintf(szFileName,TEXT("%s%s"),szCurrentPath,szitem);

            EndDialog(hDlg,1);
          }
        }
      }
      break;

    case IDCANCEL:
      EndDialog(hDlg,0);
      break;
    }
    break;

  default:
    return FALSE;
  }

  return TRUE;
}

